package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.HualalaFoodService;
import com.gxwebsoft.apps.entity.HualalaFood;
import com.gxwebsoft.apps.param.HualalaFoodParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 菜品分类控制器
 *
 * @author 科技小王子
 * @since 2023-01-12 15:34:55
 */
@Api(tags = "菜品分类管理")
@RestController
@RequestMapping("/api/apps/hualala-food")
public class HualalaFoodController extends BaseController {
    @Resource
    private HualalaFoodService hualalaFoodService;

    @PreAuthorize("hasAuthority('apps:hualalaFood:list')")
    @OperationLog
    @ApiOperation("分页查询菜品分类")
    @GetMapping("/page")
    public ApiResult<PageResult<HualalaFood>> page(HualalaFoodParam param) {
        PageParam<HualalaFood, HualalaFoodParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaFoodService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(hualalaFoodService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:list')")
    @OperationLog
    @ApiOperation("查询全部菜品分类")
    @GetMapping()
    public ApiResult<List<HualalaFood>> list(HualalaFoodParam param) {
        PageParam<HualalaFood, HualalaFoodParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaFoodService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(hualalaFoodService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:list')")
    @OperationLog
    @ApiOperation("根据id查询菜品分类")
    @GetMapping("/{id}")
    public ApiResult<HualalaFood> get(@PathVariable("id") Integer id) {
        return success(hualalaFoodService.getById(id));
        // 使用关联查询
        //return success(hualalaFoodService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:save')")
    @OperationLog
    @ApiOperation("添加菜品分类")
    @PostMapping()
    public ApiResult<?> save(@RequestBody HualalaFood hualalaFood) {
        if (hualalaFoodService.save(hualalaFood)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:update')")
    @OperationLog
    @ApiOperation("修改菜品分类")
    @PutMapping()
    public ApiResult<?> update(@RequestBody HualalaFood hualalaFood) {
        if (hualalaFoodService.updateById(hualalaFood)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:remove')")
    @OperationLog
    @ApiOperation("删除菜品分类")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (hualalaFoodService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:save')")
    @OperationLog
    @ApiOperation("批量添加菜品分类")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<HualalaFood> list) {
        if (hualalaFoodService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:update')")
    @OperationLog
    @ApiOperation("批量修改菜品分类")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<HualalaFood> batchParam) {
        if (batchParam.update(hualalaFoodService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaFood:remove')")
    @OperationLog
    @ApiOperation("批量删除菜品分类")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (hualalaFoodService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
